﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using CMS.EventLog;
using CMS.Scheduler;
using CMS.PortalControls;
using CMS.CMSImportExport;
using CMS.SiteProvider;
using CMS.GlobalHelper;
using CMS.UIControls;
using CMS.CMSHelper;
using CMS.IO;
using CMS.DocumentEngine;
using CMS.WorkflowEngine;

/// <summary>
/// Summary description for AutoExport
/// </summary>
public class AutoExport: ITask
{
    /// <summary>
    /// Executes the task.
    /// </summary>
    /// <param name="ti">Info object representing the scheduled task</param>
    public string Execute(TaskInfo ti)
    {
        string detail = "Executed from '~/App_Code/AutoExport.cs'. Task data:" + ti.TaskData;

        //Start site export code
        //Delete temporary data
        try
        {
            ExportProvider.DeleteTemporaryFiles();
        }
        catch
        {

        }

        // Prepare the properties
        //Filename of the zip export package
        string exportFileName = string.Format("Example_Site_{0:yyyy-MM-dd_hh-mm}.zip", DateTime.Now);

        //Path to the SiteUtilsFolder
        string exportFilePath = FileHelper.GetFullFolderPhysicalPath(ImportExportHelper.GetSiteUtilsFolder(), "~/") + "Export\\" + exportFileName;

        //Code name of the site you want to export
        string siteName = "CorporateSite";

        // Ensure that site exists
        if (SiteInfoProvider.GetSiteInfo(siteName) != null)
        {
            // Ensure there is no exported package with the same name
            if (!File.Exists(exportFilePath))
            {
                // Export as Global Admin
                ExportProvider.ExportSite(siteName, exportFilePath, "~/", false, UserInfoProvider.GetUserInfo("administrator"));
            }
        }

        // Logs the execution of the task in the event log.
        EventLogProvider.LogInformation("AutoExport", "Execute", detail);

        return null;
    }
}